#ifndef __3DVIEWER_H_
#define __3DVIEWER_H_

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xresource.h>
#include <X11/keysym.h>

#include <math.h>

#include "growinggrid.h"
#include "growingaxonlist.h"
#include "growingaxonhead.h"

class C3D_Viewer {

private:
    void C3D_Viewer::getxy(
			   int a,
			   int b,
			   float h,
			   
			   float eye_a,
			   float eye_b,
			   float eye_h,
			   float angle,
		       
			   int &x,
			   int &y);

    void init_windows();
    void setUpGCs();

protected:
    /* The basic set of header files for any Xlib program */
    Display *display;  /* Server or display to which a connection will be made */
    int screen;        /* Screen number to use on that display */
    Window win;        /* The applications one and only window */
    XEvent event;      /* The event data structure */
    GC gc1, gc2;       /* Graphics context data structures */
    XGCValues gs1,gs2; /* Graphics context settings */
    


    int level;
    int subs;

    float me_a;
    float me_b;
    float me_h;
    float me_an;

    bool initialized;


    float delta_h;
    float augen_x;
    float augen_y;
    int horizonty;



    void viereck(
		 int a1, int b1, float h1,
		 int a2, int b2, float h2,
		 int a3, int b3, float h3,
		 int a4, int b4, float h4);
    void wuerfel(
		 int a1, int b1, int h1,
		 int a2, int b2, int h2,
		 int a3, int b3, int h3,
		 int a4, int b4, int h4,
		 int a5, int b5, int h5,
		 int a6, int b6, int h6,
		 int a7, int b7, int h7,
		 int a8, int b8, int h8);

    virtual void drawInToWindow(CGrowing_Grid &growing_grid){};
    virtual void print_status(){};

public:
    C3D_Viewer();
    virtual ~C3D_Viewer();
    void show(CGrowing_Grid &growing_grid);
};




class C3D_Viewer_Occupied:public C3D_Viewer
{
protected:
    void drawInToWindow(CGrowing_Grid &growing_grid);
    void print_status();
public:
    C3D_Viewer_Occupied();
    ~C3D_Viewer_Occupied();
};



class C3D_Viewer_Concentration:public C3D_Viewer
{
protected:
    void drawInToWindow(CGrowing_Grid &growing_grid);
    void print_status();
public:
    C3D_Viewer_Concentration();
    ~C3D_Viewer_Concentration();
};


#endif // __3DVIEWER_H_
