#include "cell.h"

// ********************************************************************
// ************************** CCell ***********************************
// ********************************************************************
CCell::CCell()
{
    out_value = in_value = 0;
};

CCell::~CCell()
{
    //nothing to be done
};

float CCell::get_out_value()
{
    return out_value;
};

// ********************************************************************
// ************************** CNeuron *********************************
// ********************************************************************
CNeuron::CNeuron()
{
    //nothing to be done
};

CNeuron::~CNeuron()
{
    //nothing to be done
};

void CNeuron::set_threshold(
			    float value
			    )
{
    threshold = value;
};

void CNeuron::process()
{
    if (in_value>=threshold)
	{
	    out_value = OUT_IF_THRESHOLD_EXCEEDED;
	    in_value = IN_IF_THRESHOLD_EXCEEDED;
	}
    else
	{
	    out_value = OUT_IF_THRESHOLD_NOT_EXCEEDED;
	    in_value = IN_IF_THRESHOLD_NOT_EXCEEDED(in_value);
	};
};

void CNeuron::incoming_stimulus(
				float value
				)
{
    in_value += value;
};
// ********************************************************************
// ************************** CSensor *********************************
// ********************************************************************
CSensor::CSensor()
{
    //nothing to be done
};

CSensor::~CSensor()
{
    //nothing to be done
};

void CSensor::process()
{
    out_value = in_value;
}

void CSensor::incoming_stimulus(
				float value
				)
{
    in_value = value;
};
// ********************************************************************
// ************************** CWheel **********************************
// ********************************************************************
CWheel::CWheel()
{
    //nothing to be done
};

CWheel::~CWheel()
{
    //nothing to be done
};

void CWheel::process()
{
    out_value = in_value;
}

void CWheel::incoming_stimulus(
			       float value
			       )
{
    in_value = value;
};
