#ifndef __CELL_H
#define __CELL_H

#include "constants.h"

class CCell{
 protected:
    float out_value;
    float in_value;
 public:
    CCell();
    virtual ~CCell();

    virtual void process() = 0;
    virtual void incoming_stimulus(
				   float value
				   ) = 0;
    float get_out_value();
};



class CNeuron : public CCell {
 private:
    float threshold;
 public:
    CNeuron();
    ~CNeuron();
    
    void set_threshold(
		       float value
		       );

    void process();
    void incoming_stimulus(
			   float value
			   );
};



class CSensor : public CCell {
 public:
    CSensor();
    ~CSensor();

    void process();
    void incoming_stimulus(
			   float value
			   );
};
    


class CWheel : public CCell {
 public:
    CWheel();
    ~CWheel();

    void process();
    void incoming_stimulus(
			   float value
			   );
};

#endif //__CELL_H
