#ifndef __GROWING_AXON_HEAD_H
#define __GROWING_AXON_HEAD_H

#include "MyBitString.h"

#include "constants.h"
#include "growing.h"
#include "3dpoint.h"

class CGrowing_Axon_Head {
 private:
    CGrowing_Axon_Cell *home;
    C3dpoint pos;
    int distance_to_home;
    int inactive_turns;
    bool still_growing;
    int following_substance_number;

    bool CGrowing_Axon_Head::grow_coordinate(
					     CGrowing_Grid &grid,
					     CGrowing_Axon_List *list,
					     float relative_conc,
					     float abs_conc,
					     int x,
					     int y,
					     int z
					     );
 public:
    CGrowing_Axon_Head(
		       C3dpoint ipos,
		       CGrowing_Axon_Cell *ihome,
		       int idistance_to_home,
		       int ifollowing_substance_number
		       );
    ~CGrowing_Axon_Head();
    
    
    int grow(
	      CGrowing_Grid &grid,
	      CGrowing_Axon_List *list
	      );
    
    
    bool get_still_growing();
    
    CGrowing_Axon_Cell *get_home();
    int get_home_number(); 
    int get_distance_to_home();

    float get_distance_to_position(
				   C3dpoint spos
				   );
};

#endif //__GROWING_AXON_HEAD_H
